package org.boilit.cup;

/**
 * Interface Scanner
 * <p/>
 * Declares the next_token() method that should be implemented by scanners.
 * This method is typically called by lr_parser.scan().
 * End-of-file can be indicated either by returning <code>new Symbol(lr_parser.EOF_sym())</code> or <code>null</code>.
 * <p/>
 * Defines the Scanner interface, which CUP uses in the default
 * implementation of <code>lr_parser.scan()</code>.  Integration
 * of scanners implementing <code>Scanner</code> is facilitated.
 *
 * @author David MacMahon <davidm@smartsc.com>
 * @version last updated 23-Jul-1999
 *          *************************************************
 */
public interface Scanner {
    /**
     * Return the next token, or <code>null</code> on end-of-file.
     */
    public Symbol next_token() throws Exception;
}
